from bubble import *
import effect
import behavior
import predicate

import logging
import math

logging.basicConfig(filename='z.log',level=logging.INFO)

if __name__ == '__main__':
    import pygBubble
    pig = pygBubble.PygBubble(800,600,60,'roid')
    control = []

    ############

    def playableBehavior(player,context):
        if (pygBubble.K_LEFT in control):
            player = player.push(-0.2,0)
        if (pygBubble.K_RIGHT in control):
            player = player.push(0.2,0)
        if (pygBubble.K_UP in control):
            player = player.push(0,-0.2)
        if (pygBubble.K_DOWN in control):
            player = player.push(0,0.2)
        return player

    def shootingBehavior(player,context):
        if (pygBubble.K_SPACE in control):
            link = player.getLink()
            x,y = player.getPosition()
            dirx,diry= player.getDirection()
            nb = bullet.translate(x,y)
            nb = nb.push(dirx,diry)
            player = player.updateLink([nb]+list(link))
        return player

    def spaceshipBehavior(player,context):
        if (pygBubble.K_LEFT in control):
            player = player.rotate(-0.1)
        if (pygBubble.K_RIGHT in control):
            player = player.rotate(0.1)
        if (pygBubble.K_UP in control):
            dirx,diry = player.getDirection()
            player = player.push(dirx*0.7,diry*0.7)
        return player

    def walkingBehavior(player,context):
        rad = player.getRadian()
        ray = 0
        if (pygBubble.K_a in control):
            rad += math.pi*0.4
            ray = 0.5
        if (pygBubble.K_d in control):
            rad -= math.pi*0.4
            ray = 0.5
        if (pygBubble.K_w in control):
            pass
        if (pygBubble.K_s in control):
            pass
        s = math.sin(rad)
        c = math.cos(rad)
        vx,vy = player.getForceVector()
        if vx==0 and vy==0:
            return player.push(s*ray,c*ray)
        return player

    bullet = {}
    rocket = {}
    universe = {}
    import json
    with open('./data/planet.json') as data:
        for bubble in bubbleFromStruct(json.load(data),effect.suite,behavior.suite,predicate.suite):
            universe=bubble
    with open('./data/bullet.json') as data:
        for bubble in bubbleFromStruct(json.load(data),effect.suite,behavior.suite,predicate.suite):
            bullet=bubble
   

    behaviors = {
        'playableBehavior':spaceshipBehavior,
        'walkingBehavior':walkingBehavior,
        'shootingBehavior':shootingBehavior
    }
    behaviors.update(behavior.suite)
    
    with open('./data/rocket.json') as data:
        for bubble in bubbleFromStruct(json.load(data),effect.suite,behaviors,predicate.suite):
            rocket=bubble
    ############

    control = pig.getControlState()
    while(not pygBubble.QUIT in control):
        pig.clearScr()
        ##################
        pig.drawBubble(rocket)
        pig.drawBubble(universe)

        rocket = rocket.against(universe)
        #################
        control = pig.getControlState()
        pig.wait()
